import pygame

from glsupport import GL_Texture 

SPRITE_PIPER = 0
SPRITE_RAT = 1
SPRITE_KID_A = 2
SPRITE_KID_B = 3
SPRITE_KID_C = 4
SPRITE_NOTE = 5

ANIMATION_IDLE = 0 # idle (standing still) animation
ANIMATION_WALK = 1 # walking animation
ANIMATION_SPECIAL_1 = 2 # playing the flute or drowning
ANIMATION_SPECIAL_2 = 3 # even more special

DIRECTION_LEFT = True
DIRECTION_RIGHT = False


SPRITE_FACING_LEFT = True
SPRITE_FACING_RIGHT = False

def create_texture_pool():
    """
    creates a sprite pool.
    Individual frames in the sprite pool can be accessed in the following fashion:
    
    sprite_pool[SPRITE][ANIMATION][FRAME]
    
    Frames are of type GL_Texture
    """
    note = GL_Texture("../img/note.png")
    
    rat_idle_1 = GL_Texture("../img/rats/ratidle1.png")
    rat_idle_2 = GL_Texture("../img/rats/ratidle2.png")
    rat_idle_3 = GL_Texture("../img/rats/ratidle3.png")
    
    anim_rat_idle = (rat_idle_1, rat_idle_2, rat_idle_1, rat_idle_3)
    
    rat_run_1 = GL_Texture("../img/rats/ratrun1.png")
    rat_run_2 = GL_Texture("../img/rats/ratrun2.png")
    rat_run_3 = GL_Texture("../img/rats/ratrun3.png")
    
    anim_rat_run = (rat_run_1, rat_run_2, rat_run_3)
    
    rat_walk_1 = GL_Texture("../img/rats/ratwalk1.png")
    rat_walk_2 = GL_Texture("../img/rats/ratwalk2.png")
    rat_walk_3 = GL_Texture("../img/rats/ratwalk3.png")
    rat_walk_4 = GL_Texture("../img/rats/ratwalk3.png")
    
    anim_rat_walk = (rat_walk_1, rat_walk_2, rat_walk_3, rat_walk_4)
    
    
    
    kid1_idle_1 = GL_Texture("../img/kid1/kid1idle1.png")
    kid1_idle_2 = GL_Texture("../img/kid1/kid1idle2.png")
    kid1_idle_3 = GL_Texture("../img/kid1/kid1idle3.png")
    kid1_idle_4 = GL_Texture("../img/kid1/kid1idle4.png")
    
    anim_kid1_idle = (kid1_idle_1, kid1_idle_2, kid1_idle_3, kid1_idle_4)
    
    kid1_walk_1 = GL_Texture("../img/kid1/kid1walk1.png")
    kid1_walk_2 = GL_Texture("../img/kid1/kid1walk2.png")
    kid1_walk_3 = GL_Texture("../img/kid1/kid1walk3.png")
    kid1_walk_4 = GL_Texture("../img/kid1/kid1walk4.png")
    kid1_walk_5 = GL_Texture("../img/kid1/kid1walk5.png")
    kid1_walk_6 = GL_Texture("../img/kid1/kid1walk6.png")
    kid1_walk_7 = GL_Texture("../img/kid1/kid1walk7.png")
    kid1_walk_8 = GL_Texture("../img/kid1/kid1walk8.png")
    
    anim_kid1_walk = (kid1_walk_1, kid1_walk_2, kid1_walk_3, kid1_walk_4,
                      kid1_walk_5, kid1_walk_6, kid1_walk_7, kid1_walk_8)
    
    
    kid2_idle_1 = GL_Texture("../img/kid2/kid2idle1.png")
    kid2_idle_2 = GL_Texture("../img/kid2/kid2idle2.png")
    kid2_idle_3 = GL_Texture("../img/kid2/kid2idle3.png")
    kid2_idle_4 = GL_Texture("../img/kid2/kid2idle4.png")
    
    anim_kid2_idle = (kid2_idle_1, kid2_idle_2, kid2_idle_3, kid2_idle_4)
    
    kid2_walk_1 = GL_Texture("../img/kid2/kid2walk1.png")
    kid2_walk_2 = GL_Texture("../img/kid2/kid2walk2.png")
    kid2_walk_3 = GL_Texture("../img/kid2/kid2walk3.png")
    kid2_walk_4 = GL_Texture("../img/kid2/kid2walk4.png")
    kid2_walk_5 = GL_Texture("../img/kid2/kid2walk5.png")
    kid2_walk_6 = GL_Texture("../img/kid2/kid2walk6.png")
    kid2_walk_7 = GL_Texture("../img/kid2/kid2walk7.png")
    kid2_walk_8 = GL_Texture("../img/kid2/kid2walk8.png")
    
    anim_kid2_walk = (kid2_walk_1, kid2_walk_2, kid2_walk_3, kid2_walk_4,
                      kid2_walk_5, kid2_walk_6, kid2_walk_7, kid2_walk_8)
    
    
    kid3_idle_1 = GL_Texture("../img/kid3/kid3idle1.png")
    kid3_idle_2 = GL_Texture("../img/kid3/kid3idle2.png")
    kid3_idle_3 = GL_Texture("../img/kid3/kid3idle3.png")
    kid3_idle_4 = GL_Texture("../img/kid3/kid3idle4.png")
    
    anim_kid3_idle = (kid3_idle_1, kid3_idle_2, kid3_idle_3, kid3_idle_4)
    
    kid3_walk_1 = GL_Texture("../img/kid3/kid3walk1.png")
    kid3_walk_2 = GL_Texture("../img/kid3/kid3walk2.png")
    kid3_walk_3 = GL_Texture("../img/kid3/kid3walk3.png")
    kid3_walk_4 = GL_Texture("../img/kid3/kid3walk4.png")
    kid3_walk_5 = GL_Texture("../img/kid3/kid3walk5.png")
    kid3_walk_6 = GL_Texture("../img/kid3/kid3walk6.png")
    kid3_walk_7 = GL_Texture("../img/kid3/kid3walk7.png")
    kid3_walk_8 = GL_Texture("../img/kid3/kid3walk8.png")
    
    
    anim_kid3_walk = (kid3_walk_1, kid3_walk_2, kid3_walk_3, kid3_walk_4,
                      kid3_walk_5, kid3_walk_6, kid3_walk_7, kid3_walk_8)
    
    
    
    
    piper_walk_1 = GL_Texture("../img/piper/piperwalk1.png")
    piper_walk_2 = GL_Texture("../img/piper/piperwalk2.png")
    piper_walk_3 = GL_Texture("../img/piper/piperwalk3.png")
    piper_walk_4 = GL_Texture("../img/piper/piperwalk4.png")
    piper_walk_5 = GL_Texture("../img/piper/piperwalk5.png")
    piper_walk_6 = GL_Texture("../img/piper/piperwalk6.png")
    piper_walk_7 = GL_Texture("../img/piper/piperwalk7.png")
    piper_walk_8 = GL_Texture("../img/piper/piperwalk8.png")
    
    anim_piper_walk = (piper_walk_1, piper_walk_2, piper_walk_3, piper_walk_4, 
                       piper_walk_5, piper_walk_6, piper_walk_7, piper_walk_8)
    
    piper_walk_play1 = GL_Texture("../img/piper/piperwalkplay1.png")
    piper_walk_play2 = GL_Texture("../img/piper/piperwalkplay2.png")
    piper_walk_play3 = GL_Texture("../img/piper/piperwalkplay3.png")
    piper_walk_play4 = GL_Texture("../img/piper/piperwalkplay4.png")
    piper_walk_play5 = GL_Texture("../img/piper/piperwalkplay5.png")
    piper_walk_play6 = GL_Texture("../img/piper/piperwalkplay6.png")
    piper_walk_play7 = GL_Texture("../img/piper/piperwalkplay7.png")
    piper_walk_play8 = GL_Texture("../img/piper/piperwalkplay8.png")
    
    anim_piper_walk_play = (piper_walk_play1,piper_walk_play2,piper_walk_play3,piper_walk_play4,
                            piper_walk_play5,piper_walk_play6,piper_walk_play7,piper_walk_play8)
    
    piper_idle_idle1 = GL_Texture("../img/piper/piperidle1.png")
    piper_idle_idle2 = GL_Texture("../img/piper/piperidle2.png")
    piper_idle_idle3 = GL_Texture("../img/piper/piperidle3.png")
    piper_idle_idle4 = GL_Texture("../img/piper/piperidle4.png")
    
    anim_piper_idle_idle = (piper_idle_idle1, piper_idle_idle2, 
                            piper_idle_idle3, piper_idle_idle4)
    
    piper_idle_playing1 = GL_Texture("../img/piper/piperplay1.png")
    piper_idle_playing2 = GL_Texture("../img/piper/piperplay2.png")
    piper_idle_playing3 = GL_Texture("../img/piper/piperplay3.png")
    piper_idle_playing4 = GL_Texture("../img/piper/piperplay4.png")
    
    anim_piper_idle_playing = (piper_idle_playing1, piper_idle_playing2,
                               piper_idle_playing3, piper_idle_playing4 )
    
    
    splash_1 = GL_Texture("../img/splash/splash1.png")
    splash_2 = GL_Texture("../img/splash/splash2.png")
    splash_3 = GL_Texture("../img/splash/splash3.png")
    splash_4 = GL_Texture("../img/splash/splash4.png")
    splash_5 = GL_Texture("../img/splash/splash5.png")
    splash_6 = GL_Texture("../img/splash/splash6.png")
    splash_7 = GL_Texture("../img/splash/splash7.png")
    splash_8 = GL_Texture("../img/splash/splash8.png")
    splash_9 = GL_Texture("../img/splash/splash9.png")
    splash_10 = GL_Texture("../img/splash/splash10.png")
    
    anim_splash = (splash_1, splash_2, splash_3, splash_4, splash_5, 
                   splash_6, splash_7, splash_8, splash_9, splash_10)
    
    
    splash_ext_1 = GL_Texture("../img/splash/splash24.png")
    splash_ext_2 = GL_Texture("../img/splash/splash25.png")
    splash_ext_3 = GL_Texture("../img/splash/splash26.png")
    splash_ext_4 = GL_Texture("../img/splash/splash27.png")
    splash_ext_5 = GL_Texture("../img/splash/splash28.png")
    splash_ext_6 = GL_Texture("../img/splash/splash29.png")
    
    anim_splash_ext = (splash_ext_1, splash_ext_2, splash_ext_3, 
                       splash_ext_4, splash_ext_5, splash_ext_6)
    
    
    return (
                 (#PIPER
                   (anim_piper_idle_idle,
                   anim_piper_walk,
                   anim_piper_idle_playing,
                   anim_piper_walk_play)
                 ),
                 (#RAT
                   anim_rat_idle,
                   anim_rat_walk,
                   anim_splash,
                   anim_rat_run
                 ),
                 (#KID A
                   anim_kid1_idle,
                   anim_kid1_walk,
                   anim_splash,
                   anim_splash_ext
                 ),
                 (#KID B
                   anim_kid2_idle,
                   anim_kid2_walk,
                   anim_splash,
                   anim_splash_ext
                 ),
                 (#KID C
                   anim_kid3_idle,
                   anim_kid3_walk,
                   anim_splash,
                   anim_splash_ext
                 ),
                 (#NOTE
                   (note,),
                   (note,),
                   (note,),
                   (note,)
                 )
                 
            )
